using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApplication333
{
    class Program
    {
        static long met(int[,] a, int n, int m, int x, int y, int xp, int yp)
        {
            if (xp == n - 1 && yp == m - 1) return a[n - 1, m - 1];
            if(xp==n-1)
            {
                long s = 0;
                for(int i = 0; i<n;i++)
                {
                    s += a[xp, i];
                }
                return a[xp, yp] + s;
            }
            if(yp==m-1)
            {
                long s = 0;
                for (int i = 0; i < m; i++)
                {
                    s += a[i, yp];
                }
                return a[xp, yp] + s;
            }
            if(xp==x-1 && y == yp)
            {
                return a[xp, yp] + met(a, n, m, x, y, xp, yp+1);
            }
            if(xp==x && y == yp-1)
            {
                return a[xp, yp] + met(a, n, m, x, y, xp + 1, yp);
            }
            long des = met(a, n, m, x, y, xp + 1, yp);
            long dole = met(a, n, m, x, y, xp, yp + 1);
            return a[xp, yp] + Math.Min(des, dole);
        }
        static void Main(string[] args)
        {
            string[] str123 = Console.ReadLine().Split();
            int n = int.Parse(str123[0]);
            int m = int.Parse(str123[1]);
            int[,] a = new int[n, m];
            for(int i = 0; i<n;i++)
            {
                string[] str1 = Console.ReadLine().Split();
                for(int j = 0; j<m;j++)
                {
                    a[i, j] = int.Parse(str1[j]);
                }
            }
            int q = int.Parse(Console.ReadLine());
            for(int i = 0; i<q;i++)
            {
                str123 = Console.ReadLine().Split();
                int x = int.Parse(str123[0]);
                int y = int.Parse(str123[1]);
                long s = met(a, n, m, x, y, 0, 0);
                Console.WriteLine(s);
            }
        }
    }
}